<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_order.php                                          ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/order_items.php");
	include($root_folder_path . "includes/date_functions.php");
	include($root_folder_path . "includes/parameters.php");

	check_admin_security("sales_orders");

	// connection to delete items
	$dbi = new VA_SQL();
	$dbi->DBDatabase = $db_name;
	$dbi->DBUser     = $db_user;
	$dbi->DBPassword = $db_password;
	$dbi->DBHost     = $db_host;

	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_info'";
	$db->query($sql);
	while($db->next_record()) {
		$order_info[$db->f("setting_name")] = $db->f("setting_value");
	}

	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='credit_card_info'";
	$db->query($sql);
	while($db->next_record()) {
		$credit_card_info[$db->f("setting_name")] = $db->f("setting_value");
	}

	$r = new VA_Record($table_prefix . "orders");

	$r->add_hidden("s_w", TEXT);
	$r->add_hidden("s_s", INTEGER);

	$r->add_where("order_id", INTEGER);

	$order_statuses = get_db_values("SELECT * FROM " . $table_prefix . "order_statuses", "");

	$r->add_select("order_status", INTEGER, $order_statuses);
	
	$r->get_form_values();
	$operation = get_param("operation");
	$order_id = get_param("order_id");
	$send_links = get_param("send_links");

	$search_links = "?s_w=" . urlencode($r->get_value("s_w")) . "&s_s=" . urlencode($r->get_value("s_s"));
	$return_page = $send_links ? "admin_order_links.php" .  $search_links . "&order_id=" . $order_id : "admin_orders.php" . $search_links;


	if(strlen($operation))
	{
		if($operation == "delete")
		{
			if($r->is_empty("order_id"))
				$r->errors .= "Missing <b>Order number</b>.<br>";

			if(!strlen($r->errors))
				$r->errors = $db->query("DELETE FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, TEXT)) ? "" : "Database Error";

			if(!strlen($r->errors))
			{
				$db->query("SELECT download_id FROM " . $table_prefix . "items_downloads WHERE order_id=" . $db->tosql($order_id, INTEGER));
				while($db->next_record())
				{
					$sql  = " DELETE FROM " . $table_prefix . "items_downloads_statistic ";	
					$sql .= " WHERE download_id=" . $dbi->tosql($db->f("download_id"), NUMBER);
					$dbi->query($sql);
				}
				$db->query("DELETE FROM " . $table_prefix . "items_downloads WHERE order_id=" . $db->tosql($order_id, INTEGER));
				$db->query("DELETE FROM " . $table_prefix . "orders_items_properties WHERE order_id=" . $dbi->tosql($order_id, INTEGER));

				$db->query("SELECT order_item_id,item_id,quantity FROM " . $table_prefix . "orders_items WHERE order_id=" . $db->tosql($order_id, INTEGER));
				while($db->next_record())
				{
					$order_item_id = $db->f("order_item_id");
					$sql  = " UPDATE " . $table_prefix . "items SET ";	
					$sql .= " stock_level=stock_level+" . $dbi->tosql($db->f("quantity"), NUMBER);
					$sql .= " WHERE item_id=" . $dbi->tosql($db->f("item_id"), NUMBER);
					$dbi->query($sql);
				}
				$r->errors = $db->query("DELETE FROM " . $table_prefix . "orders_items WHERE order_id=" . $db->tosql($order_id, INTEGER)) ? "" : "Database Error";
			}
		}
		else if($operation == "save")
		{
			if($r->is_empty("order_id"))
				$r->errors .= "Missing <b>Order number</b>.<br>";

			if(!strlen($r->errors))
				$r->errors = $r->update_record() ? "" : "Database error";

			if(!strlen($r->errors)) {
				$sql = "SELECT download_activation FROM " . $table_prefix . "order_statuses WHERE status_id=" . $db->tosql($r->get_value("order_status"), INTEGER);
				$download_action = get_db_value($sql);
				if($download_action == 1) {
					$sql = "UPDATE " . $table_prefix . "items_downloads SET activated=1 WHERE order_id=" . $db->tosql($order_id, INTEGER);
					$db->query($sql);
				} else if($download_action == 0) {
					$sql = "UPDATE " . $table_prefix . "items_downloads SET activated=0 WHERE order_id=" . $db->tosql($order_id, INTEGER);
					$db->query($sql);
				}
			}
		}

		if(!strlen($r->errors))
		{
			header("Location: " . $return_page);
			exit;
		}

	}

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_order.html");
	$t->set_var("order_id", $order_id);

	$t->set_var("s_w_url", urlencode($r->get_value("s_w")));
	$t->set_var("s_s_url", urlencode($r->get_value("s_s")));

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_orders_href", "admin_orders.php");
	$t->set_var("admin_order_href", "admin_order.php");
	$t->set_var("admin_order_links_href", "admin_order_links.php");

	$items_text = show_order_items($order_id);

	$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "orders_items oi ";
	$sql .= " WHERE oi.order_id=" . $db->tosql($order_id, INTEGER);
	$sql .= " AND oi.downloadable=1 ";
	$downloadable_products = get_db_value($sql);
	if($downloadable_products) {
		$t->parse("download_links", false);
	}

	$sql = "SELECT COUNT(*) FROM " . $table_prefix . "items_downloads WHERE order_id=" . $db->tosql($order_id, INTEGER);
	$links_number = get_db_value($sql);
	$downloadable_links = ($links_number > 0) ? 1 : 0;
	$t->set_var("downloadable_links", $downloadable_links);

	$sql = "SELECT status_id, download_activation FROM " . $table_prefix . "order_statuses ";
	$db->query($sql);
	while($db->next_record())	{
		$t->set_var("status_id", $db->f("status_id"));
		$t->set_var("download_activation", $db->f("download_activation"));
		$t->parse("os_array", true);
	}

	$personal_number = 0;
	$delivery_number = 0;
	for($i = 0; $i < sizeof($parameters); $i++)
	{                                    
		$r->add_textbox($parameters[$i], TEXT);
		$r->add_textbox("delivery_" . $parameters[$i], TEXT);
		if($order_info["show_" . $parameters[$i]] == 1) {
			$personal_number++;
		} else {
			$r->parameters[$parameters[$i]][SHOW] = false;
		}
		if($order_info["show_delivery_" . $parameters[$i]] == 1) {
			$delivery_number++;
		} else {
			$r->parameters["delivery_" . $parameters[$i]][SHOW] = false;
		}
	}

	$r->add_textbox("cc_name", TEXT);
	$r->add_textbox("cc_number", TEXT);
	$r->add_textbox("cc_start_date", DATETIME);
	$r->change_property("cc_start_date", VALUE_MASK, array("MM", " / ", "YYYY"));
	$r->add_textbox("cc_expiry_date", DATETIME);
	$r->change_property("cc_expiry_date", VALUE_MASK, array("MM", " / ", "YYYY"));
	$r->add_textbox("cc_type", INTEGER);
	$r->add_textbox("cc_issue_number", INTEGER);
	$r->add_textbox("cc_security_code", TEXT);
	$r->add_textbox("pay_without_cc", TEXT);
	if ($credit_card_info["show_pay_without_cc"] != 1) {
		$r->parameters["pay_without_cc"][SHOW] = false;
	}

	$r->get_db_values();

	if($r->parameters["pay_without_cc"][SHOW] && !$r->is_empty("pay_without_cc")) {
		for($i = 0; $i < sizeof($cc_parameters); $i++) { 
			$r->parameters[$cc_parameters[$i]][SHOW] = false;
		}
	} else {
		$r->parameters["pay_without_cc"][SHOW] = false;
	}

	$r->set_value("state_code", get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($r->get_value("state_code"), TEXT)));
	$r->set_value("country_code", get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($r->get_value("country_code"), TEXT)));
	$r->set_value("delivery_state_code", get_db_value("SELECT state_name FROM " . $table_prefix . "states WHERE state_code=" . $db->tosql($r->get_value("delivery_state_code"), TEXT)));
	$r->set_value("delivery_country_code", get_db_value("SELECT country_name FROM " . $table_prefix . "countries WHERE country_code=" . $db->tosql($r->get_value("delivery_country_code"), TEXT)));
	$r->set_value("cc_type", get_db_value("SELECT credit_card_name FROM " . $table_prefix . "credit_cards WHERE credit_card_id=" . $db->tosql($r->get_value("cc_type"), INTEGER)));


	$r->set_parameters();

	if($personal_number > 0) {
		$t->parse("personal", false);
	}

	if($delivery_number > 0) {
		$t->parse("delivery", false);
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>