<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  admin_support_request.php                                ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/date_functions.php");

	check_admin_security("support");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_support_request.html");

	$t->set_var("admin_support_request_href", "admin_support_request.php");

	$admin_support_url = new VA_URL("admin_support.php", false);
	$admin_support_url->add_parameter("s_w", REQUEST, "s_w");
	$admin_support_url->add_parameter("s_s", REQUEST, "s_s");
	$admin_support_url->add_parameter("sort_ord", REQUEST, "sort_ord");
	$admin_support_url->add_parameter("sort_dir", REQUEST, "sort_dir");
	$return_page = $admin_support_url->get_url();
	$t->set_var("admin_support_url", $return_page);

	$operation = get_param("operation");
	$support_id = get_param("support_id");
	$rp = get_param("rp");
	$return_page = (strlen($rp) && $operation != "delete") ? $rp : $return_page;

	$r = new VA_Record($table_prefix . "support");
	$r->return_page = $return_page;

	$r->add_where("support_id", INTEGER);

	$r->add_hidden("s_w", TEXT);
	$r->add_hidden("s_s", TEXT);
	$r->add_hidden("sort_ord", TEXT);
	$r->add_hidden("sort_dir", TEXT);

	$r->add_textbox("user_name", TEXT);
	$r->parameters["user_name"][REQUIRED] = true;
	$r->add_textbox("user_email", TEXT, "Customer Email");
	$r->parameters["user_email"][REQUIRED] = true;
	$r->add_textbox("identifier", TEXT);
	$r->add_textbox("environment", TEXT);
	$r->add_textbox("remote_address", TEXT);


	$number_of_products = get_db_value("SELECT COUNT(*) FROM " . $table_prefix . "support_products");
	$support_products = get_db_values("SELECT * FROM " . $table_prefix . "support_products", array(array("", "Select Product")));
	$r->add_select("support_product_id", INTEGER, $support_products, "Product");
	$r->parameters["support_product_id"][REQUIRED] = true;
	if($number_of_products < 1) {
		$r->parameters["support_product_id"][SHOW] = false;
	}

	$admins = get_db_values("SELECT admin_id, admin_name FROM " . $table_prefix . "admins ", array(array("", "Select Responsible")));
	$r->add_select("admin_id_assign_to", INTEGER, $admins);

	$support_types = get_db_values("SELECT * FROM " . $table_prefix . "support_types", array(array("", "Select Type")));
	$r->add_select("support_type_id", INTEGER, $support_types, "Type");
	$r->parameters["support_type_id"][REQUIRED] = true;

	$support_statuses = get_db_values("SELECT * FROM " . $table_prefix . "support_statuses", array(array("", "Select Status")));
	$r->add_select("support_status_id", INTEGER, $support_statuses);

	$support_priorities = get_db_values("SELECT * FROM " . $table_prefix . "support_priorities", array(array("", "Select Priority")));
	$r->add_select("support_priority_id", INTEGER, $support_priorities);

	$r->add_textbox("summary", TEXT, "Summary");
	$r->parameters["summary"][REQUIRED] = true;
	$r->add_textbox("description", TEXT);
	$r->parameters["description"][REQUIRED] = true;

	$r->add_textbox("date_added", DATETIME);
	$r->change_property("date_added", USE_IN_UPDATE, false);
	$r->add_textbox("date_modified", DATETIME);

	$r->get_form_values();

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $support_id)
		{
			$db->query("DELETE FROM " . $table_prefix . "support WHERE support_id=" . $db->tosql($support_id, INTEGER));
			$db->query("DELETE FROM " . $table_prefix . "support_messages WHERE support_id=" . $db->tosql($support_id, INTEGER));
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $r->validate();

		if($is_valid)
		{
			$r->set_value("date_added", va_time());
			$r->set_value("date_modified", va_time());
			if($number_of_products < 1) {
				$r->set_value("support_product_id", 0);
			}

			if(strlen($r->get_value("support_id")))
				$r->update_record();
			else
				$r->insert_record();

			header("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($r->get_value("support_id")))
	{
		$r->get_db_values();
	}
	else // new item (set default values)
	{
	}

	$r->set_parameters();
	
	if(strlen($support_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add New");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_support_href", "admin_support.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("rp", htmlspecialchars($return_page));

	$t->pparse("main");

?>
