<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  block_products_list.php                                  ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/
                           

function products_list($block_name)
{
	global $t;
	global $db, $table_prefix;
	global $settings;
	global $page_settings;
	global $category_id;
	global $HTTP_GET_VARS;
	global $sc_item_id, $sc_category_id, $item_added, $sc_errors;

	if(get_setting_value($page_settings, $block_name . "_column_hide", 0)) {
		return;
	}

	$t->set_file("block_body", "block_products_list.html");
	$t->set_var("NO_PRODUCTS_MSG",  NO_PRODUCTS_MSG);
	$t->set_var("TOP_CATEGORY_MSG", TOP_CATEGORY_MSG);
	$t->set_var("MORE_MSG",         MORE_MSG);
	$t->set_var("READ_MORE_MSG",    READ_MORE_MSG);
	$t->set_var("CLICK_HERE_MSG",   CLICK_HERE_MSG);
	$t->set_var("PRICE_MSG",        PRICE_MSG);
	$t->set_var("OUR_PRICE_MSG",    OUR_PRICE_MSG);
	$t->set_var("YOU_SAVE_MSG",     YOU_SAVE_MSG);
	$t->set_var("RATING_MSG",       RATING_MSG);
	$t->set_var("PROD_AVAILABILITY_MSG", PROD_AVAILABILITY_MSG);
	$t->set_var("ADD_TO_CART_MSG",  ADD_TO_CART_MSG);
	$t->set_var("VIEW_CART_MSG",    VIEW_CART_MSG);
	$t->set_var("AMEND_CART_MSG",   AMEND_CART_MSG);
	$t->set_var("GOTO_CHECKOUT_MSG",GOTO_CHECKOUT_MSG);

	$currency_left = "";
	$currency_right = "";
	if($settings["currency_position"] == 1)
		$currency_left = $settings["currency_sign"];
	else if($settings["currency_position"] == 2)
		$currency_right = $settings["currency_sign"];
		
	$category_id = get_param("category_id");
	$search_category_id = get_param("search_category_id");
	$search_string = trim(get_param("search_string"));
	$is_search = strlen($search_string);
	$search_values = "";

	if($is_search) {
		$category_id = $search_category_id;
		$search_values = split(" ", $search_string);
	}
	if(!strlen($category_id)) $category_id = "0";

	$t->set_var("products_href", "products.php");
	$t->set_var("product_details_href", "product_details.php");
	$t->set_var("basket_href", "basket.php");
	$t->set_var("checkout_href", "checkout.php");
	$t->set_var("reviews_href", "reviews.php");
	$t->set_var("cl", $currency_left);
	$t->set_var("cr", $currency_right);
	
	$n = new VA_Navigator($settings["templates_dir"], "navigator.html", "products.php");

	// generate page link with query parameters
	$page = "products.php";
	$remove_parameters = array("rnd", "cart", "item_id", "ic_id", "rp");
	$query_string = get_query_string($HTTP_GET_VARS, $remove_parameters, "", false);
	$page	.= $query_string;
	$cart_link  = $page;
	$cart_link .= strlen($query_string) ? "&" : "?";
	srand ((double) microtime() * 1000000);
	$random_value = rand();
	$cart_link .= "rnd=" . $random_value . "&";

	$t->set_var("rnd", $random_value);
	$t->set_var("rp_url", urlencode($page));
	$t->set_var("rp", htmlspecialchars($page));

	$search_tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree", TOP_CATEGORY_MSG);
	$search_tree->show($category_id);

	// set up variables for navigator
	if($is_search && $category_id != 0) {
		$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "items i, " . $table_prefix . "items_categories ic, " . $table_prefix . "categories c ";
		$sql .= " WHERE i.item_id=ic.item_id AND c.category_id = ic.category_id ";
		$sql .= " AND (ic.category_id = " . $db->tosql($search_category_id, INTEGER);
		$sql .= " OR c.category_path LIKE '" . $db->tosql($search_tree->get_path($search_category_id), TEXT, false) . "%')";
	} 
	else
	{
		$sql  = " SELECT COUNT(*) FROM " . $table_prefix . "items i, " . $table_prefix . "items_categories ic WHERE i.item_id=ic.item_id ";
		if(!$is_search)
			$sql .= " AND ic.category_id = " . $db->tosql($category_id, INTEGER);
	}
	$sql .= " AND i.is_showing=1 AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	if($is_search) {
		for($si = 0; $si < sizeof($search_values); $si++) {
			$sql .= " AND i.item_name LIKE '%" . $db->tosql($search_values[$si], TEXT, false) . "%'";
		}
	}

	$db->query($sql);
	$db->next_record();
	$total_records = $db->f(0);

	$t->set_var("total_records", $total_records);
	$t->set_var("search_string", htmlspecialchars($search_string));

	$records_per_page = get_setting_value($page_settings, "products_per_page", 10);
	$pages_number = 5;
	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$total_pages = ceil($total_records / $records_per_page);

	$sql  = " SELECT i.item_id, i.item_name, i.short_description, i.small_image, i.big_image, ";
	$sql .= " i.price, i.sales_price, i.discount_percent, i.buy_link, i.votes, i.points, ";
	$sql .= " i.is_sales, m.affiliate_code, ic.category_id, ";
	$sql .= " i.stock_level, st_in.shipping_time_desc AS in_stock_message, st_out.shipping_time_desc AS out_stock_message ";
	$sql .= " FROM (((((" . $table_prefix . "items i ";
	$sql .= " INNER JOIN " . $table_prefix . "items_categories ic ON i.item_id=ic.item_id) ";
	if($is_search && $category_id != 0)
		$sql .= "INNER JOIN " . $table_prefix . "categories c ON c.category_id = ic.category_id)";
	else 
		$sql .= ")";
	$sql .= " LEFT JOIN " . $table_prefix . "manufacturers m ON i.manufacturer_id=m.manufacturer_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_in ON i.shipping_in_stock=st_in.shipping_time_id) ";
	$sql .= " LEFT JOIN " . $table_prefix . "shipping_times st_out ON i.shipping_out_stock=st_out.shipping_time_id) ";
	//$sql .= " LEFT JOIN " . $table_prefix . "items_properties ip ON i.item_id=ip.item_id) ";
	$sql .= " WHERE i.is_showing=1 ";
	if($is_search && $category_id != 0)
	{
		$sql .= " AND (ic.category_id = " . $db->tosql($search_category_id, INTEGER);
		$sql .= " OR c.category_path LIKE '" . $db->tosql($search_tree->get_path($search_category_id), TEXT, false) . "%')";
	} else if(!$is_search)
		$sql .= " AND ic.category_id = " . $db->tosql($category_id, INTEGER);
	$sql .= " AND ((i.hide_out_of_stock=1 AND i.stock_level > 0) OR i.hide_out_of_stock=0)";
	if($is_search) {
		for($si = 0; $si < sizeof($search_values); $si++) {
			$sql .= " AND i.item_name LIKE '%" . $db->tosql($search_values[$si], TEXT, false) . "%'";
			//$sql .= " OR ip.property_description LIKE '%" . $db->tosql($search_values[$si], TEXT, false) . "%')";
		}
	}
	$sql .= " ORDER BY item_order ";

	$t->set_var("category_id", $category_id);

	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	$db->query($sql);
	if($db->next_record())
	{
		$columns = get_setting_value($page_settings, "products_columns", 1);
		$t->set_var("total_columns", $columns);
		$item_number = 0;
		do
		{
			$item_number++;
			$item_id = $db->f("item_id");
			$ic_id = $db->f("category_id");
			$form_id = $ic_id . "_" . $item_id;
			$item_name = $db->f("item_name");

			$properties = show_items_properties($item_id, $form_id);
			$is_properties  = $properties["is_any"];
			$properties_ids = $properties["ids"];
			$selected_price = $properties["price"];

			$t->set_var("item_id", $item_id);
			$t->set_var("ic_id", $ic_id);
			$t->set_var("form_id", $form_id);
			$t->set_var("item_name", $item_name);
			$t->set_var("item_name_strip", htmlspecialchars(strip_tags($item_name)));

			$t->set_var("item_added", "");
			$t->set_var("sc_errors", "");
			if($item_id == $sc_item_id && $sc_category_id == $ic_id) {
				if ($sc_errors) {
					$t->set_var("errors_list", $sc_errors);
					$t->parse("sc_errors", false);
				} else if ($item_added) {
					$added_message = str_replace("{product_name}", $item_name, ADDED_PRODUCT_MSG);
					$t->set_var("added_message", $added_message);
					$t->parse("item_added", false);
				}
			} 

			$stock_level = $db->f("stock_level");
			if ($stock_level > 0) {
				$shipping_time_desc = $db->f("in_stock_message");
			} else {
				$shipping_time_desc = $db->f("out_stock_message");
			}
			if(strlen($shipping_time_desc))
			{
				$t->set_var("shipping_time_desc", $shipping_time_desc);
				$t->parse("availability", false);
			}
			else
				$t->set_var("availability", "");
			
			$short_description = $db->f("short_description");
			if($short_description) 
			{
				$t->set_var("short_description", nl2br($short_description));
				$t->parse("description", false);
			}
			else
			{
				$t->set_var("description", "");
			}
			$small_image = $db->f("small_image");
			if($small_image)
			{
        $image_size = preg_match("/^http\:\/\//", $small_image) ? "" : @GetImageSize($small_image);
        $t->set_var("alt", htmlspecialchars($item_name));
        $t->set_var("src", htmlspecialchars($small_image));
				if(is_array($image_size))
				{
	        $t->set_var("width", "width=\"" . $image_size[0] . "\"");
  	      $t->set_var("height", "height=\"" . $image_size[1] . "\"");
				}
				else
				{
	        $t->set_var("width", "");
  	      $t->set_var("height", "");
				}
				$t->parse("small_image", false);
			}
			else
			{
				$t->set_var("small_image", "");
			}

			$price = $db->f("price");
			$sales_price = $db->f("sales_price");
			$is_sales = $db->f("is_sales");
			$base_price = calculate_price($price, $is_sales, $sales_price);
			$t->set_var("base_price", $base_price);
			if($sales_price > 0 && $sales_price != $price && $is_sales)
			{
				$discount_percent = round($db->f("discount_percent"), 0);
				if(!$discount_percent) 
					$discount_percent = round(($price - $sales_price) / ($price / 100), 0);

				$t->set_var("discount_percent", $discount_percent);

				$t->set_var("price_class", "realprice");
				$t->set_var("price", $currency_left . number_format($price, 2) . $currency_right);
				$t->set_var("sales_price", $currency_left . number_format($sales_price + $selected_price, 2) . $currency_right);
				$t->set_var("you_save", $currency_left . number_format($price - $sales_price, 2) . $currency_right);
				$t->parse("sales", false);
				$t->parse("save", false);
			}
			else
			{
				$t->set_var("price_class", "ourprice");
				$t->set_var("price", $currency_left . number_format($price + $selected_price, 2) . $currency_right);
				$t->set_var("sales", "");
				$t->set_var("save", "");
			}

			$buy_link = $db->f("buy_link");
			if($buy_link)
				$t->set_var("buy_href", $db->f("buy_link") . $db->f("affiliate_code"));
			else if($is_properties)
				$t->set_var("buy_href", "javascript:document.form_" . $form_id . ".submit();");
			else 
				$t->set_var("buy_href", $cart_link . "cart=ADD&item_id=" . $item_id . "&ic_id=" . $ic_id. "&rp=". urlencode($page). "#p" . $item_id);

			if($settings["reviews_availability"]) {
				$votes = $db->f("votes");
				$points = $db->f("points");

				$rating_float = $votes ? round($points / $votes, 2) : 0;
				$rating_int = round($rating_float, 0);
				if($rating_int)
				{
					$rating_alt = $rating_float;
					$rating_image = "rating_" . $rating_int . ".gif";
				}
				else
				{
					$rating_alt = "Rate it!";
					$rating_image = "not_rated.gif";
				}

				$t->set_var("rating_image", $rating_image);
				$t->set_var("rating_alt", $rating_alt);
				$t->parse("reviews", false);
			} 
			
			$t->parse("items_cols");
			$is_next_record = $db->next_record();
			if($item_number % $columns == 0)
			{
				if($is_next_record)
					$t->parse("delimiter", false);
				else 
					$t->set_var("delimiter", "");
				$t->parse("items_rows");
				$t->set_var("items_cols", "");
			}
		} while ($is_next_record);              	
		$t->set_var("delimiter", "");

		if($item_number % $columns != 0)
			$t->parse("items_rows");
		
		if ($total_pages > 1)
			$t->parse("search_and_navigation", false);

		$t->parse("block_body", false);
		$t->set_var("no_items", "");
	}
	else
	{
		$t->set_var("items_rows", "");
		$t->parse("no_items", false);
		$t->parse("block_body", false);
	}
	
	// show search results information
	if($is_search) {
		$found_message = str_replace("{found_records}", $total_records, FOUND_PRODUCTS_MSG);
		$found_message = str_replace("{search_string}", htmlspecialchars($search_string), $found_message);
		$t->set_var("FOUND_PRODUCTS_MSG", $found_message);
		$t->parse("search_results", false);
		$t->parse("search_and_navigation", false);
		$t->parse("block_body", false);
	} 

	$t->parse($block_name, true);

}

?>