<?
	// version information
	$version_name = "shop";
	$version_type = "enterprise";
	$version_number = "2.1.5";

  session_start();
	
	include_once ("./includes/constants.php");
	include_once ("./includes/common_functions.php");
	$language_code = get_language("messages.php");
	include_once ("./messages/".$language_code."/messages.php");
	include_once ("./messages/".$language_code."/install_messages.php");
	include_once ("./includes/date_functions.php");
	include_once ("./includes/record.php");
	include_once ("./includes/template.php");
	if ( file_exists("./includes/var_definition.php") ) {
		include_once ("./includes/var_definition.php");
	}

	$db_library = get_param("db_library");
	if($db_library) {
		include_once ("./includes/db_$db_library.php");
		$db = new VA_SQL();
		$db->DBType     = get_param("db_type");
		$db->DBDatabase = get_param("db_name");
		$db->DBHost     = get_param("db_host");
		$db->DBPort     = get_param("db_port");
		$db->DBUser     = get_param("db_user");
		$db->DBPassword = get_param("db_password");
		$db->DBPersistent = get_param("db_persistent");
		$table_prefix   = "va_";
	}

	$t = new VA_Template("./templates/default/");
  $t->set_file("main", "install.html");
  $t->set_var("install_href", "install.php");
  $t->set_var("select_date_format_href", "select_date_format.php");
	$t->set_var("step_1", "");
	$t->set_var("step_2", "");
	$t->set_var("step_3", "");
	$t->set_var("INSTALL_TITLE",      INSTALL_TITLE);
                                                       
	$t->set_var("INSTALL_STEP_1_TITLE",INSTALL_STEP_1_TITLE);
	$t->set_var("INSTALL_STEP_1_DESC", INSTALL_STEP_1_DESC);
	$t->set_var("INSTALL_STEP_2_TITLE",INSTALL_STEP_2_TITLE);
	$t->set_var("INSTALL_STEP_2_DESC", INSTALL_STEP_2_DESC);
	$t->set_var("INSTALL_FINAL_TITLE", INSTALL_FINAL_TITLE);
	                                                     
	$t->set_var("DB_SETTINGS_MSG",    DB_SETTINGS_MSG);
	$t->set_var("ADMIN_SETTINGS_MSG", ADMIN_SETTINGS_MSG);
	$t->set_var("DATE_SETTINGS_MSG",  DATE_SETTINGS_MSG);
	$t->set_var("ERRORS_MSG",         ERRORS_MSG);
	$t->set_var("SELECT_FROM_LIST_MSG",SELECT_FROM_LIST_MSG);

	$t->set_var("DB_TYPE_FIELD",      DB_TYPE_FIELD);
	$t->set_var("DB_PHP_LIB_FIELD",   DB_PHP_LIB_FIELD);
	$t->set_var("DB_HOST_FIELD",      DB_HOST_FIELD);
	$t->set_var("DB_PORT_FIELD",      DB_PORT_FIELD);
	$t->set_var("DB_NAME_FIELD",      DB_NAME_FIELD);
	$t->set_var("DB_USER_FIELD",      DB_USER_FIELD);
	$t->set_var("DB_PASS_FIELD",      DB_PASS_FIELD);
	$t->set_var("DB_PERSISTENT_FIELD",DB_PERSISTENT_FIELD);
	$t->set_var("POPULATE_DB_FIELD",  POPULATE_DB_FIELD);
	$t->set_var("POPULATE_DB_DESC",   POPULATE_DB_DESC);

	$t->set_var("SITE_URL_FIELD",       SITE_URL_FIELD);
	$t->set_var("ADMIN_EMAIL_FIELD",    ADMIN_EMAIL_FIELD);
	$t->set_var("ADMIN_LOGIN_FIELD",    ADMIN_LOGIN_FIELD);
	$t->set_var("ADMIN_PASS_FIELD",     ADMIN_PASS_FIELD);
	$t->set_var("ADMIN_CONF_FIELD",     ADMIN_CONF_FIELD);
	$t->set_var("DATETIME_SHOWN_FIELD", DATETIME_SHOWN_FIELD);
	$t->set_var("DATE_SHOWN_FIELD",     DATE_SHOWN_FIELD);
	$t->set_var("DATETIME_EDIT_FIELD",  DATETIME_EDIT_FIELD);
	$t->set_var("DATE_EDIT_FIELD",      DATE_EDIT_FIELD);

	$t->set_var("INSTALL_FINISHED_MSG",INSTALL_FINISHED_MSG);
	$t->set_var("ACCESS_ADMIN_MSG",    ACCESS_ADMIN_MSG);
	$t->set_var("ADMIN_URL_MSG",       ADMIN_URL_MSG);
	$t->set_var("SITE_URL_MSG",        SITE_URL_MSG);
	$t->set_var("THANKS_MSG",          THANKS_MSG);

	$t->set_var("BACK_BUTTON",        BACK_BUTTON);
	$t->set_var("NEXT_BUTTON",        NEXT_BUTTON);

	$operation = get_param("operation");
	$step = get_param("step");
	if(!$step) $step = 1;

	if ($operation == "back" && $step > 1) {
		$step--;
	}
	
	$r = new VA_Record("", "step_" . $step);
	if (defined("INSTALLED") && INSTALLED) {
		$r->errors = INSTALL_FINISHED_ERROR . "<br>\n";
	}

	$r->add_hidden("operation", TEXT);
	if ( file_exists("./includes/var_definition.php") ) {
		if ( !is_writable ("./includes/var_definition.php") ) {
			$r->errors = WRITE_FILE_ERROR . "<br>\n";
		}
	} else if ( !is_writable ("./includes/") ) {
		$r->errors = WRITE_DIR_ERROR . "<br>\n";
	}

	$db_libraries = array (
		array("", SELECT_PHP_LIB_MSG),
		array("mysql",   "MySQL"),
		array("postgre", "Postgre"),
		array("odbc",    "ODBC"),
	);

	$db_types = array (
		array("", SELECT_DB_TYPE_MSG),
		array("mysql",   "MySQL"),
		array("postgre", "Postgre"),
		array("access",  "Access"),
	);

	// step 1 parameters
	$r->add_select("db_library", TEXT, $db_libraries, DB_PHP_LIB_FIELD);
	$r->change_property("db_library", REQUIRED, true);
	$r->add_select("db_type", TEXT, $db_types, DB_TYPE_FIELD);
	$r->add_textbox("db_host", TEXT);
	$r->change_property("db_host", DEFAULT_VALUE, "localhost");
	$r->add_textbox("db_name", TEXT, DB_NAME_FIELD);
	$r->add_textbox("db_port", TEXT);
	$r->change_property("db_name", REQUIRED, true);
	$r->add_textbox("db_user", TEXT);
	$r->add_textbox("db_password", TEXT);
	$r->add_checkbox("db_persistent", INTEGER);
	$r->add_checkbox("db_populate", INTEGER);
	$r->change_property("db_populate", DEFAULT_VALUE, 1);

	// step 2 parameters
	$r->add_textbox("site_url", TEXT, SITE_URL_FIELD);
	$r->add_textbox("admin_email", TEXT, ADMIN_EMAIL_FIELD);
	$r->add_textbox("admin_login", TEXT, ADMIN_LOGIN_FIELD);
	$r->add_textbox("admin_password", TEXT, ADMIN_PASS_FIELD);
	$r->add_textbox("admin_password_confirm", TEXT, ADMIN_CONF_FIELD);

	$r->add_textbox("datetime_show_format", TEXT, DATETIME_SHOWN_FIELD);
	$r->add_textbox("date_show_format",     TEXT, DATE_SHOWN_FIELD);
	$r->add_textbox("datetime_edit_format", TEXT, DATETIME_EDIT_FIELD);
	$r->add_textbox("date_edit_format",     TEXT, DATE_EDIT_FIELD);

	if($step == "1" && !$r->errors)  {

		$r->get_form_values();
		if($r->get_value("db_library") == "odbc") {
			$r->change_property("db_type", REQUIRED, true);
		}
		if($operation == "save") {
			$is_valid = $r->validate();
			if($is_valid) {
				$db->HaltOnError = "no";
				if(!$db->connect()) {
					$r->errors  = DB_CONNECT_ERROR . "<br>";
					if($db->Error) {
						$r->errors .= $db->Error;
					}
				} else if ($r->get_value("db_populate")) {
					$is_access = ($r->get_value("db_type") == "access");
					if($r->get_value("db_library") == "odbc") {
						$db_filename = $r->get_value("db_type") . "_viart_shop.sql";
					} else {
						$db_filename = $r->get_value("db_library") . "_viart_shop.sql";
					}
					$dump_sql = "./db/" . $db_filename;
					$sql = "";
					if (file_exists($dump_sql)) {
						$sql_strings = file($dump_sql);
						for($i = 0; $i < sizeof($sql_strings); $i++) {
							$sql_string = $sql_strings[$i];
							if (preg_match ("/\;\s*$/i", $sql_strings[$i])) {
								$sql_string = preg_replace ("/;\s*$/i", "", $sql_string);
								$sql .= $sql_string;
								if (preg_match ("/^\s*DROP\s+/i", $sql)) {
									$drop_table_syntax = true;
								} else {
									$drop_table_syntax = false;
								}
								if ($is_access) {
									$sql = str_replace("\\n", "\n", $sql);
									$sql = str_replace("\\t", "\t", $sql);
									$sql = str_replace("\\r", "\r", $sql);
								}
								$db->query($sql);
								if($db->Error && !$drop_table_syntax) {
									$r->errors .= $db->Error . "<br>";
								}
								$sql = "";
							} else {
								$sql .= $sql_string;
							}
						}
					} else {
						$dump_file_error = str_replace("{file_name}", $dump_sql, DUMP_FILE_ERROR);
						$r->errors = $dump_file_error;
					}
				}
				if(!$r->errors) { // move to step 2
					$operation = "";
					$step = 2;
					$r->set_record_name("step_" . $step);
				}
			} 
		} else if (!$operation) {
			$r->set_default_values();
		}
	}



	if($step == "2")  {

		$r->change_property("db_library",    CONTROL_TYPE, HIDDEN);
		$r->change_property("db_type",       CONTROL_TYPE, HIDDEN);
		$r->remove_property("db_host",       DEFAULT_VALUE);
		$r->change_property("db_persistent", CONTROL_TYPE, HIDDEN);
		$r->change_property("db_populate",   CONTROL_TYPE, HIDDEN);

		$http_host = getenv("HTTP_HOST");
		$server_port = getenv("SERVER_PORT");
		$request_uri = getenv("REQUEST_URI");
		$script_name = getenv("SCRIPT_NAME");
		
		$path = ($request_uri) ? $request_uri : $script_name;
		$path = dirname($path);
		$path = str_replace("\\", "/", $path);
		if($path != "/") { $path .= "/"; }

		$site_url  = "http://";
		$site_url .= ($server_port == 80 || !$server_port) ?  $http_host : $http_host . ":" . $server_port;
		$site_url .= $path;

		$r->change_property("site_url",               REQUIRED, true);
		$r->change_property("site_url",               DEFAULT_VALUE, $site_url);
		$r->change_property("admin_email",            REQUIRED, true);
		$r->change_property("admin_email",            REGEXP_MASK, EMAIL_REGEXP);
		$r->change_property("admin_login",            REQUIRED, true);
		$r->change_property("admin_login",            MIN_LENGTH, 3);
		$r->change_property("admin_password",         REQUIRED, true);
		$r->change_property("admin_password",         MIN_LENGTH, 3);
		$r->change_property("admin_password",         MATCHED, "admin_password_confirm");

		$r->change_property("datetime_show_format",   REQUIRED, true);
		$r->change_property("date_show_format",       REQUIRED, true);
		$r->change_property("datetime_edit_format",   REQUIRED, true);
		$r->change_property("date_edit_format",       REQUIRED, true);

		$r->get_form_values();

		if(!$r->errors) {
			// check connect and for existings tables
			$db->HaltOnError = "no";
			if(!$db->connect()) {
				$r->errors  = DB_CONNECT_ERROR . "<br>";
				if($db->Error) {
					$r->errors .= $db->Error;
				}
			} else {
				if ( !$db->query("SELECT * FROM " . $table_prefix . "global_settings") ) {
					$db_table_error = str_replace("{table_name}", "global_settings", DB_TABLE_ERROR);
					$r->errors .= $db_table_error . "<br>";
					if($db->Error) {
						$r->errors .= "<b>" . DATABASE_ERROR_MSG . "</b>: " . $db->Error . ".<br>";
					}
				}
				if ( !$db->query("SELECT * FROM " . $table_prefix . "admins") ) {
					$db_table_error = str_replace("{table_name}", "admins", DB_TABLE_ERROR);
					$r->errors .= $db_table_error . "<br>";
					if($db->Error) {
						$r->errors .= "<b>" . DATABASE_ERROR_MSG . "</b>: " . $db->Error . ".<br>";
					}
				}
			}
		}

		if($operation == "save" && !$r->errors) {
			$is_valid = $r->validate();

			if($is_valid) {
				//$db->HaltOnError = "yes";

				// build var_definition.php file
				build_config();

				// set site url
				$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='global' AND setting_name='site_url'";
				$db->query($sql);
				$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ";
				$sql .= " ('global', 'site_url', " . $db->tosql($r->get_value("site_url"), TEXT) . ")";
				$db->query($sql);

				// set admin email
				$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='global' AND setting_name='admin_email'";
				$db->query($sql);
				$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ";
				$sql .= " ('global', 'admin_email', " . $db->tosql($r->get_value("admin_email"), TEXT) . ")";
				$db->query($sql);

				// set version information
				$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type='version' ";
				$db->query($sql);
				$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ";
				$sql .= " ('version', 'version', " . $db->tosql($version_name, TEXT) . ")";
				$db->query($sql);
				$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ";
				$sql .= " ('version', 'type', " . $db->tosql($version_type, TEXT) . ")";
				$db->query($sql);
				$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ";
				$sql .= " ('version', 'number', " . $db->tosql($version_number, TEXT) . ")";
				$db->query($sql);
				$sql  = " INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES ";
				$sql .= " ('version', 'installed', " . $db->tosql(time(), TEXT) . ")";
				$db->query($sql);

				// set administrator
				$sql = "DELETE FROM " . $table_prefix . "admins";
				$db->query($sql);
				$sql  = " INSERT INTO " . $table_prefix . "admins (admin_id, admin_name, privilege_id, email, login, password) VALUES (";
				$sql .= "1, ";
				$sql .= $db->tosql($r->get_value("admin_login"), TEXT) . ", ";
				$sql .= "1, ";
				$sql .= $db->tosql($r->get_value("admin_email"), TEXT) . ", ";
				$sql .= $db->tosql($r->get_value("admin_login"), TEXT) . ", ";
				$sql .= $db->tosql($r->get_value("admin_password"), TEXT) . ") ";
				$db->query($sql);

				set_session("session_admin_id", "1");
				set_session("session_admin_privilege_id", "1");
				set_session("session_admin_name", $r->get_value("admin_login"));
				        
				$step = 3;
				$r->set_record_name("step_" . $step);
			}
		} else {
			$r->set_default_values();
		}
	}


	$r->set_parameters();

	$t->set_var("step", $step);
	$t->parse("step_" . $step, $step);
  $t->pparse("main", false);


	function build_config()
	{
		global $r;

		$db_type = $r->get_value("db_type");
		if(!$db_type) { $db_type = $r->get_value("db_library"); }
		$db_persistent = $r->get_value("db_persistent") ? "true" : "false";

		$fp = fopen("./includes/var_definition.php", "w");
		fwrite($fp, "<?php\n\n");
		fwrite($fp, "\tdefine(\"INSTALLED\", true); // set to false if you want run install.php\n");
		fwrite($fp, "\tdefine(\"DEBUG\",     true); // debug mode - set false on live site\n\n");

		fwrite($fp, "\t// version information\n");
		fwrite($fp, "\tdefine(\"VERSION_NAME\", \"shop\");\n");
		fwrite($fp, "\tdefine(\"VERSION_TYPE\", \"enterprise\");\n");
		fwrite($fp, "\tdefine(\"VERSION_NUMBER\", \"2.1.5\");\n\n");
	
		fwrite($fp, "\t// database parameters\n");
		fwrite($fp, "\t\$db_lib        = \"" . $r->get_value("db_library") . "\"; // mysql | postgre | odbc\n");
		fwrite($fp, "\t\$db_type       = \"" . $db_type . "\"; // mysql | postgre | access\n");
		fwrite($fp, "\t\$db_name       = \"" . $r->get_value("db_name") . "\";\n");
		fwrite($fp, "\t\$db_host       = \"" . $r->get_value("db_host") . "\";\n");
		fwrite($fp, "\t\$db_port       = \"" . $r->get_value("db_port") . "\";\n");
		fwrite($fp, "\t\$db_user       = \"" . $r->get_value("db_user") . "\";\n");
		fwrite($fp, "\t\$db_password   = \"" . $r->get_value("db_password") . "\";\n");
		fwrite($fp, "\t\$db_persistent = " . $db_persistent .";\n\n");

		fwrite($fp, "\t\$table_prefix  = \"va_\";\n\n");

		fwrite($fp, "\t\$default_language = \"en\";\n\n");

		$datetime_show_format = parse_date_format($r->get_value("datetime_show_format"));
		$date_show_format     = parse_date_format($r->get_value("date_show_format"));
		$datetime_edit_format = parse_date_format($r->get_value("datetime_edit_format"));
		$date_edit_format     = parse_date_format($r->get_value("date_edit_format"));
		fwrite($fp, "\t// date parameters\n");
		fwrite($fp, "\t\$datetime_show_format = " . build_date_array($datetime_show_format) . ";\n");
		fwrite($fp, "\t\$date_show_format     = " . build_date_array($date_show_format) . ";\n");
		fwrite($fp, "\t\$datetime_edit_format = " . build_date_array($datetime_edit_format) . ";\n");
		fwrite($fp, "\t\$date_edit_format     = " . build_date_array($date_edit_format) . ";\n\n");

		fwrite($fp, "\t// session settings\n");
		fwrite($fp, "\t\$session_prefix = \"" . $r->get_value("db_name") . "\";\n\n");

		fwrite($fp, "?>");
		fclose($fp);
	}

	function build_date_array($mask)
	{
		$mask_array = "";
		for($i = 0; $i < sizeof($mask); $i++) {
			$mask_array .= ($i) ? ", " : "array(";
			$mask_array .= "\"" . addslashes($mask[$i]) . "\"";
		}
		$mask_array .= ")";
		return $mask_array;
	}

?>