<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Online Shop Enterprise 2.1.5                              ***
  ***      File:  order_info.php                                           ***
  ***      Built: Sat Apr  9 12:37:03 2005                                 ***
  ***      http://www.codetosell.com                                       ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./includes/common.php");
	include("./includes/record.php");
	include("./includes/shopping_cart.php");
	include("./includes/date_functions.php");
	include("./includes/parameters.php");
	include_once ("./messages/".$language_code."/cart_messages.php");

	$currency_left = ""; $currency_right = "";
	if($settings["currency_position"] == 1)
		$currency_left = $settings["currency_sign"];
	else if($settings["currency_position"] == 2)
		$currency_right = $settings["currency_sign"];

	$variables = array();

	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='shipping'";
	$db->query($sql);
	while($db->next_record()) {
		$shipping_settings[$db->f("setting_name")] = $db->f("setting_value");
	}

  $t = new VA_Template("./js");
  $t->set_file("ordering_js","ordering.js");
	$t->set_var("REQUIRED_PROPERTY_MSG", REQUIRED_PROPERTY_MSG);
	$t->set_var("REQUIRED_DELIVERY_MSG", REQUIRED_DELIVERY_MSG);
	$t->parse("ordering_js", false);

	$t->templates_path = $settings["templates_dir"];
  $t->set_file("main","order_info.html");
	$t->set_var("site_url", $settings["site_url"]);
	$t->set_var("order_info_href", "order_info.php");
	$t->set_var("currency_left", htmlspecialchars($currency_left));
	$t->set_var("currency_rigt", htmlspecialchars($currency_right));

	$t->set_var("CHECKOUT_INFO_TITLE", CHECKOUT_INFO_TITLE);     
	$t->set_var("CART_TITLE",          CART_TITLE);     
	$t->set_var("EMPTY_CART_MSG",      EMPTY_CART_MSG);     
	$t->set_var("PROD_TITLE_COLUMN",   PROD_TITLE_COLUMN);     
	$t->set_var("PROD_QTY_COLUMN",     PROD_QTY_COLUMN);         
	$t->set_var("PROD_PRICE_COLUMN",   PROD_PRICE_COLUMN);       
	$t->set_var("PROD_TOTAL_COLUMN",   PROD_TOTAL_COLUMN);  
	$t->set_var("GOODS_TOTAL_MSG",     GOODS_TOTAL_MSG); 
	$t->set_var("CART_TOTAL_MSG",      CART_TOTAL_MSG);     

	$t->set_var("PERSONAL_DETAILS_MSG", PERSONAL_DETAILS_MSG);
	$t->set_var("DELIVERY_DETAILS_MSG", DELIVERY_DETAILS_MSG);
	$t->set_var("SAME_DETAILS_MSG",   SAME_DETAILS_MSG);
	$t->set_var("REGISTER_BUTTON",    REGISTER_BUTTON);
	$t->set_var("UPDATE_BUTTON",      UPDATE_BUTTON);
	$t->set_var("CANCEL_BUTTON",      CANCEL_BUTTON);
	$t->set_var("LOGIN_FIELD",        LOGIN_FIELD);
	$t->set_var("PASSWORD_FIELD",     PASSWORD_FIELD);
	$t->set_var("CONFIRM_PASS_FIELD", CONFIRM_PASS_FIELD);
	$t->set_var("NAME_FIELD",         NAME_FIELD);
	$t->set_var("FIRST_NAME_FIELD",   FIRST_NAME_FIELD);
	$t->set_var("LAST_NAME_FIELD",    LAST_NAME_FIELD);
	$t->set_var("COMPANY_NAME_FIELD", COMPANY_NAME_FIELD);
	$t->set_var("EMAIL_FIELD",        EMAIL_FIELD);
	$t->set_var("STREET_FIRST_FIELD", STREET_FIRST_FIELD);
	$t->set_var("STREET_SECOND_FIELD",STREET_SECOND_FIELD);
	$t->set_var("CITY_FIELD",         CITY_FIELD);
	$t->set_var("PROVINCE_FIELD",     PROVINCE_FIELD);
	$t->set_var("STATE_FIELD",        STATE_FIELD);
	$t->set_var("ZIP_FIELD",          ZIP_FIELD);
	$t->set_var("COUNTRY_FIELD",      COUNTRY_FIELD);
	$t->set_var("PHONE_FIELD",        PHONE_FIELD);
	$t->set_var("DAYTIME_PHONE_FIELD",DAYTIME_PHONE_FIELD);
	$t->set_var("EVENING_PHONE_FIELD",EVENING_PHONE_FIELD);
	$t->set_var("CELL_PHONE_FIELD",   CELL_PHONE_FIELD);
	$t->set_var("FAX_FIELD",          FAX_FIELD);
	$t->set_var("CONTINUE_BUTTON",    CONTINUE_BUTTON);

	$items = ""; $items_text = "";

	$total_buying = 0; $goods_total = 0; $total_items = 0;
	$total_quantity = 0; $weight_total = 0; $order_total = 0;

	$sc_errors = "";
	$operation = get_param("operation");
	$is_update = ($operation == "save");
	$shopping_cart = get_session("shopping_cart");
	$user_id = get_session("session_user_id");
	$cart_items = array();
	if(!strlen($user_id)) $user_id = 0;

	if(is_array($shopping_cart))
	{
		$properties_ids = "";
		reset($shopping_cart);
		while(list($cart_id, $item) = each($shopping_cart))
		{
			$item_id = $item["ITEM_ID"];
			$properties = $item["PROPERTIES"];
			$quantity = $item["QUANTITY"];

			$sql  = " SELECT item_name, short_description, full_description, buying_price, price, item_type_id, ";
			$sql .= " stock_level, small_image, is_sales, sales_price, stock_level, weight,  ";
			$sql .= " downloadable, download_period, download_path ";
			$sql .= " FROM " . $table_prefix . "items ";
			$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);

			$db->query($sql);
			if($db->next_record())
			{
				$total_items++;
				// some price calculation
				$price = calculate_price($db->f("price"), $db->f("is_sales"), $db->f("sales_price"));

				$buying_price = $db->f("buying_price");
				$item_name = $db->f("item_name");
				$downloadable = $db->f("downloadable");
				$download_period = $db->f("download_period");
				$download_path = $db->f("download_path");
				$item_type_id = $db->f("item_type_id");
				$stock_level = $db->f("stock_level");
				$weight = $db->f("weight");
				$short_description = strip_tags($db->f("short_description"));
				$full_description = strip_tags($db->f("full_description"));

				// set item variables into html
				$t->set_var("cart_id", $cart_id);
				$t->set_var("item_name", $item_name);
				$t->set_var("item_name_strip", htmlspecialchars(strip_tags($item_name)));
				$t->set_var("quantity", $quantity);				

				$t->set_var("small_image", $db->f("small_image"));				

				// show properties if their available
				$properties_info = array();
				$properties_values = ""; $properties_values_text = ""; $properties_values_html = "";
				$additional_price = 0; $additional_weight = 0;

				$sql  = " SELECT * ";
				$sql .= " FROM " . $table_prefix . "items_properties ";
				$sql .= " WHERE item_id=" . $item_id;
				$sql .= " ORDER BY use_on_checkout, property_id ";
				$db->query($sql);
				if ($db->next_record()) {
					$pr_rows = array(); $rn = 0;
					do {
						$pr_rows[$rn]["property_id"] = $db->f("property_id");
						$pr_rows[$rn]["property_name"] = $db->f("property_name");
						$pr_rows[$rn]["property_description"] = $db->f("property_description");
						$pr_rows[$rn]["control_type"] = $db->f("control_type");
						$pr_rows[$rn]["control_style"] = $db->f("control_style");
						$pr_rows[$rn]["required"] = $db->f("required");
						$pr_rows[$rn]["use_on_checkout"] = $db->f("use_on_checkout");
						$pr_rows[$rn]["start_html"] = $db->f("start_html");
						$pr_rows[$rn]["middle_html"] = $db->f("middle_html");
						$pr_rows[$rn]["end_html"] = $db->f("end_html");
						$rn++;
					} while ($db->next_record());

					for ($rn = 0; $rn < sizeof($pr_rows); $rn++) {
						$property_id = $pr_rows[$rn]["property_id"];
						$property_name = $pr_rows[$rn]["property_name"];
						$property_description = $pr_rows[$rn]["property_description"];
						$control_type = $pr_rows[$rn]["control_type"];
						$control_style = $pr_rows[$rn]["control_style"];
						$property_required = $pr_rows[$rn]["required"];
						$use_on_checkout = $pr_rows[$rn]["use_on_checkout"];
						$start_html = $pr_rows[$rn]["start_html"];
						$middle_html = $pr_rows[$rn]["middle_html"];
						$end_html = $pr_rows[$rn]["end_html"];
						$cp_id = $cart_id . "_" . $property_id;

						$property_value = ""; $pr_add_weight = 0; $pr_add_price = 0;
						if ($use_on_checkout) {
							if ($is_update) {
					    	$property_value_param = get_param("property_" . $cart_id . "_" . $property_id);
							} else if (is_array($properties) && isset($properties[$property_id])) {
								$property_value_param = $properties[$property_id][0];
							} else {
								$property_value_param = "";
							}
							if($properties_ids) $properties_ids .= ",";
							$properties_ids .= $cp_id;
							$property_control  = "<input type=\"hidden\" name=\"property_name_" . $cp_id . "\"";
							$property_control .= " value=\"" . htmlspecialchars($property_name) . "\">";
							$property_control .= "<input type=\"hidden\" name=\"property_required_" . $cp_id . "\"";
							$property_control .= " value=\"" . intval($property_required) . "\">";
							$property_control .= "<input type=\"hidden\" name=\"property_control_" . $cp_id . "\"";
							$property_control .= " value=\"" . strtoupper($control_type) . "\">";

							if(strtoupper($control_type) == "LISTBOX") {
								$properties_options = "<option value=\"\">Select " . $property_name . "</option>\n";
								$sql = "SELECT * FROM " . $table_prefix . "items_properties_values WHERE property_id=" . $property_id . " AND hide_value=0";
								$db->query($sql);
								while($db->next_record())
								{
									$item_property_id = $db->f("item_property_id");
									$opt_add_price    = round($db->f("additional_price"), 2);
									$opt_add_weight   = round($db->f("additional_weight"), 4);
									$opt_value        = $db->f("property_value");
									$option_selected = "";
									if($item_property_id == $property_value_param) {
										$additional_weight += $opt_add_weight;
										$additional_price += $opt_add_price;
										$pr_add_weight = $opt_add_weight; 
										$pr_add_price = $opt_add_price;
										$option_selected = " selected ";
										$property_value = $opt_value;
									}
									$properties_options .= "<option " . $option_selected . " value=\"" . htmlspecialchars($item_property_id) . "\">";
									$properties_options .= htmlspecialchars($opt_value);
									if($opt_add_price > 0)
										$properties_options .= " (+ " . $currency_left . number_format($opt_add_price, 2) . $currency_right . ")";
									else if ($additional_price < 0)
										$properties_options .= " (- " . $currency_left . number_format(abs($opt_add_price), 2) . $currency_right . ")";
									$properties_options .= "</option>\n";
								}
								$property_control .= "<select name=\"property_" . $cp_id . "\"";
								if ($control_style) {	
									$property_control .= " style=\"" . $control_style . "\"";
								}
								$property_control .= ">" . $properties_options . "</select>";
								$property_control .= $end_html;
							} else if(strtoupper($control_type) == "RADIOBUTTON" || strtoupper($control_type) == "CHECKBOXLIST") {
								$property_control .= "<span";
								if ($control_style) {	$property_control .= " style=\"" . $control_style . "\""; }
								$property_control .= ">";
								$sql = "SELECT * FROM " . $table_prefix . "items_properties_values WHERE property_id=" . $property_id . " AND hide_value=0";
								$db->query($sql);
								while($db->next_record())
								{
									$item_property_id = $db->f("item_property_id");
									$opt_add_price    = round($db->f("additional_price"), 2);
									$opt_add_weight   = round($db->f("additional_weight"), 4);
									$opt_value        = $db->f("property_value");
									$option_checked   = "";
									if($item_property_id == $property_value_param) {
										$additional_weight += $opt_add_weight;
										$additional_price += $opt_add_price;
										$pr_add_weight = $opt_add_weight; 
										$pr_add_price = $opt_add_price;
										$option_checked = " checked ";
										$property_value = $opt_value;
									}
									$property_control .= "<input type=\"radio\" name=\"property_" . $cp_id . "\" ". $option_checked;
									$property_control .= "value=\"" . htmlspecialchars($item_property_id) . "\">";
									$property_control .= $opt_value;
									if($opt_add_price > 0)
										$property_control .= " (+ " . $currency_left . number_format($opt_add_price, 2) . $currency_right . ")";
									else if ($opt_add_price < 0)
										$property_control .= " (- " . $currency_left . number_format(abs($opt_add_price), 2) . $currency_right . ")";
									$property_control .= $end_html;
								}
								$property_control .= "</span>";
							} else if (strtoupper($control_type) == "TEXTBOX") {
								$property_value = $property_value_param;
								$property_control .= "<input type=\"text\" name=\"property_" . $cp_id . "\"";
								if ($control_style) {	
									$property_control .= " style=\"" . $control_style . "\"";
								}
								$property_control .= " value=\"" . htmlspecialchars($property_value) . "\">";
								$property_control .= $end_html;
							} else if (strtoupper($control_type) == "TEXTAREA") {
								$property_value = $property_value_param;
								$property_control .= "<textarea name=\"property_" . $cp_id . "\"";
								if ($control_style) {	
									$property_control .= " style=\"" . $control_style . "\"";
								}
								$property_control .= ">" . htmlspecialchars($property_value) . "</textarea>";
								$property_control .= $end_html;
							} else {
								if ($property_required) {
									$property_value = $property_value_param;
									$property_control .= "<input type=\"hidden\" name=\"property_" . $cp_id . "\" value=\"" . htmlspecialchars($property_description) . "\">";
								}
								$property_control .= "<span";
								if ($control_style) {	
									$property_control .= " style=\"" . $control_style . "\"";
								}
								$property_control .= ">" . $property_description . "</span>";
								$property_control .= $end_html;
							}
							if($is_update) {
								$shopping_cart[$cart_id]["PROPERTIES"][$property_id] = array($property_value_param);
								if ($property_required && !strlen($property_value)) {
									$property_error = str_replace("{property_name}", $property_name, REQUIRED_PROPERTY_MSG);
									$property_error = str_replace("{product_name}", $item_name, $property_error);
									$sc_errors .= $property_error . "<br>";
								}
							}
							$properties_values_html .= "<br>" . $start_html . $property_name . ": " . $middle_html . $property_control;
							if ($property_value) {
								if(strlen($properties_values_text)) $properties_values_text .= "; ";
								$properties_values .= "<br>" . $property_name . ": " . $property_value;
								$properties_values_text .= $property_name . ": " . $property_value;
								$properties_info[] = array($property_id, $property_name, $property_value, $pr_add_price, $pr_add_weight);
							}

						} else if (is_array($properties) && isset($properties[$property_id])) {
							$property_values = $properties[$property_id];
							$values_list = "";
							if(strtoupper($control_type) == "LISTBOX" || strtoupper($control_type) == "RADIOBUTTON" 
								|| strtoupper($control_type) == "CHECKBOXLIST") {
								for($pv = 0; $pv < sizeof($property_values); $pv++) {
									$sql  = " SELECT property_value, additional_price, additional_weight ";
									$sql .= " FROM " . $table_prefix . "items_properties_values ipv ";
									$sql .= " WHERE property_id=" . $db->tosql($property_id, INTEGER);
									$sql .= " AND item_property_id=" . $db->tosql($property_values[$pv], INTEGER);
									$db->query($sql);
									if($db->next_record()) {
										$pr_add_price = $db->f("additional_price");
										$pr_add_weight = $db->f("additional_weight");
										$additional_price += $pr_add_price;
										$additional_weight += $pr_add_weight;
										if ($values_list) { $values_list .= ", "; } 
										$values_list .= $db->f("property_value");
									} else {
										$shopping_cart[$cart_id]["PROPERTIES"][$property_id] = "";
										unset($shopping_cart[$cart_id]["PROPERTIES"][$property_id]);
									}
								}
							} else {
								$values_list = $property_values[0];
							}

							if ($values_list) {
								if(strlen($properties_values_text)) $properties_values_text .= "; ";
								$properties_values .= "<br>" . $property_name . ": " . $values_list;
								$properties_values_html .= "<br>" . $property_name . ": " . $values_list;
								$properties_values_text .= $property_name . ": " . $values_list;
								$properties_info[] = array($property_id, $property_name, $values_list, $pr_add_price, $pr_add_weight);
							}
						}
					}

				}
				$t->set_var("properties_values", $properties_values_html);

				$total_buying += ($buying_price * $quantity); 
				$price = round($price + $additional_price, 2);
				$item_total = $price * $quantity;
				$goods_total += $item_total;
				$total_quantity += $quantity;
				$weight_total += ($weight + $additional_weight);

				$weight += $additional_weight;
				$cart_items[] = array(
					"item_id" => $item_id, "id" => $item_id, "product_id" => $item_id, 
					"weight" => $weight, "price" => $price, "quantity" => $quantity,
					"buying_price" => $buying_price, "item_name" => $item_name, "product_name" => $item_name, 
					"product_title" => $item_name, "item_title" => $item_name, "item_total" => $item_total,
					"downloadable" => $downloadable, "item_type_id" => $item_type_id, "stock_level" => $stock_level,
					"short_description" => $short_description, "description" => $short_description, 
					"full_description" => $full_description
				);

				$item_text = $item_name;
				if(strlen($properties_values_text))
					$item_text .= " (" . $properties_values_text . ")";
				$item_text .= " Qty:" . $quantity . " " . $currency_left . number_format($item_total, 2) . $currency_right;
				$items_text .= $item_text . "\n";

				$t->set_var("price", $currency_left . number_format($price, 2) . $currency_right);
				$t->set_var("item_total", $currency_left . number_format($item_total, 2) . $currency_right);

				$items[] = array($item_id, $item_type_id, $item_name, $properties_info, $properties_values, $buying_price, $price, ($weight + $additional_weight), $quantity, $downloadable, $download_period, $download_path);
				$t->parse("items", true);
			}
		}
		if($is_update) {
			set_session("shopping_cart", $shopping_cart);
		}
		$t->set_var("properties_ids", $properties_ids);

		$t->set_var("total_quantity", $total_quantity);
		$variables["total_quantity"] = $total_quantity;
		$t->set_var("total_items", $total_items);
		$variables["total_items"] = $total_items;

		$t->set_var("goods_value", $goods_total);
		$t->set_var("goods_total", $currency_left . number_format($goods_total, 2) . $currency_right);
		$items_text .= "Goods Total: " . $currency_left . number_format($goods_total, 2) . $currency_right . "\n";
		$order_total = round($goods_total, 2);

	}
	$basket_parsed = false;


	if(!is_array($items) || sizeof($items) == 0)
	{
		header("Location: basket.php");
		exit;
	}

	$sql = "SELECT setting_name,setting_value FROM " . $table_prefix . "global_settings WHERE setting_type='order_info'";
	$db->query($sql);
	while($db->next_record()) {
		$order_info[$db->f("setting_name")] = $db->f("setting_value");
	}

	// prepare country_code for use
	if($order_info["show_country_code"] != 1 && $order_info["show_delivery_country_code"] != 1) {
		$country_code = $settings["country_code"];
	} else if(strlen($operation)) {
		if ($order_info["show_delivery_country_code"] == 1) {
			$country_code = get_param("delivery_country_code");
		} else {
			$country_code = get_param("country_code");
		}
	} else if($user_id) { // get user details 
		$sql  = " SELECT country_code,delivery_country_code FROM " . $table_prefix . "users WHERE user_id=" . $db->tosql($user_id, INTEGER);
		$db->query($sql);
		if($db->next_record()) {
			if ($order_info["show_delivery_country_code"] == 1) {
				$country_code = $db->f("delivery_country_code");
			} else {
				$country_code = $db->f("country_code");
			}
		}
	} else { // get default country from cookies
		if ($order_info["show_delivery_country_code"] == 1) {
			$country_code = get_cookie("cookie_delivery_country_code");
		} else {
			$country_code = get_cookie("cookie_country_code");
		}
	}

	// prepare shipping
	$shipping_type_id = ""; $shipping_type_desc = ""; $shipping_cost = 0; $total_shipping_types = 0;
	if ($country_code) {
		$shipping_type_id_param = get_param("shipping_type_id");
		$sql  = " SELECT st.shipping_type_id, st.shipping_type_desc, st.cost_per_order, ";
		$sql .= " st.cost_per_product, st.cost_per_weight ";
		$sql .= " FROM " . $table_prefix . "shipping_types st, " . $table_prefix . "shipping_types_countries stc ";
		$sql .= " WHERE st.shipping_type_id=stc.shipping_type_id ";
		$sql .= " AND stc.country_code=" . $db->tosql($country_code, TEXT);
		$db->query($sql);
		while($db->next_record()) {
			$total_shipping_types++;
			$row_shipping_type_id = $db->f("shipping_type_id");
			$row_shipping_type_desc = $db->f("shipping_type_desc");
			$cost_per_order = $db->f("cost_per_order");
			$cost_per_product = $db->f("cost_per_product");
			$cost_per_weight = $db->f("cost_per_weight");
			$row_shipping_cost = $cost_per_order + ($cost_per_product * $total_quantity) + ($cost_per_weight * $weight_total);
  
			if ($row_shipping_type_id == $shipping_type_id_param) {
				$shipping_type_id   = $row_shipping_type_id;
				$shipping_type_desc = $row_shipping_type_desc;
				$shipping_cost = $row_shipping_cost;
				$items_text .= $shipping_type_desc . ": " . $currency_left . number_format($shipping_cost, 2) . $currency_right . "\n";
				$t->set_var("shipping_type_checked", "checked");
				$t->set_var("shipping_cost_selected", $currency_left . number_format($row_shipping_cost, 2) . $currency_right);
			} else {
				$t->set_var("shipping_type_checked", "");
				$t->set_var("shipping_cost_selected", "");
			}
			$t->set_var("shipping_type_id", $row_shipping_type_id);
			$t->set_var("shipping_value", round($row_shipping_cost, 2));
			$t->set_var("shipping_cost_desc", $currency_left . number_format($row_shipping_cost, 2) . $currency_right);
			$t->set_var("shipping_type_desc", $row_shipping_type_desc);
			$t->parse("shipping_types", true);
		}
		if($total_shipping_types == 1) {
			$shipping_type_id   = $row_shipping_type_id;
			$shipping_type_desc = $row_shipping_type_desc;
			$shipping_cost = $row_shipping_cost;
			$t->set_var("shipping_types", "");
			$t->parse("shipping_type", false);
		}
	}
	$order_total += round($shipping_cost, 2);

	// prepare tax
	$tax_name = ""; $tax_percent = 0; $tax_cost = 0;
	if(strlen($country_code)) 
	{
		$sql  = " SELECT tax_name, tax_percent FROM " . $table_prefix . "tax_rates ";
		$sql .= " WHERE country_code=" . $db->tosql($country_code, TEXT);
		$db->query($sql);
		if($db->next_record()) {
			$tax_name = $db->f("tax_name");
			$tax_percent = $db->f("tax_percent");
			$tax_cost = ($order_total * $tax_percent) / 100;
			$tax_cost = round($tax_cost, 2);
			$order_total += $tax_cost;
			$t->set_var("tax_percent", $tax_percent);
			$t->set_var("tax_name", $tax_name);
			$t->set_var("tax_cost", $currency_left . number_format($tax_cost, 2) . $currency_right);
			$t->set_var("tax_total", $currency_left . number_format($tax_cost, 2) . $currency_right);
			$t->parse("tax", false);
			$items_text .= $tax_name . ": " . $currency_left . number_format($tax_cost, 2) . $currency_right . "\n";
		}
	}

	// order total string
	$items_text .= "Order Total: " . $currency_left . number_format($order_total, 2) . $currency_right;
	$t->set_var("order_total_desc", $currency_left . number_format($order_total, 2) . $currency_right);
	
	//$order_id = get_param("order_id");
	$r = new VA_Record($table_prefix . "orders");

	$r->add_where("order_id", INTEGER);
	$r->add_textbox("user_id", INTEGER);
	$r->add_textbox("affiliate_code", TEXT);
	$r->change_property("affiliate_code", USE_SQL_NULL, false);
	$r->add_textbox("order_status", INTEGER);
	$r->add_textbox("total_buying", NUMBER);
	$r->add_textbox("goods_total", NUMBER);
	$r->add_textbox("total_quantity", NUMBER);
	$r->add_textbox("weight_total", NUMBER);
	$r->add_textbox("total_discount", NUMBER);
	$r->add_textbox("shipping_type_id", INTEGER);
	$r->add_textbox("shipping_type_desc", TEXT);
	$r->add_textbox("shipping_cost", NUMBER);
	$r->add_textbox("tax_name", TEXT);
	$r->add_textbox("tax_percent", NUMBER);
	$r->add_textbox("tax_total", NUMBER);
	$r->add_textbox("order_total", NUMBER);
	$r->add_textbox("order_placed_date", DATETIME);

	$states = get_db_values("SELECT state_code,state_name FROM " . $table_prefix . "states ORDER BY state_name ", array(array("", "Non US")));
	$countries = get_db_values("SELECT country_code,country_name FROM " . $table_prefix . "countries ORDER BY country_order, country_name ", array(array("", "Select Country")));

	$r->add_textbox("name", TEXT, "Name");
	$r->change_property("name", USE_SQL_NULL, false);
	$r->add_textbox("first_name", TEXT, "First Name");
	$r->change_property("first_name", USE_SQL_NULL, false);
	$r->add_textbox("last_name", TEXT, "Last Name");
	$r->change_property("last_name", USE_SQL_NULL, false);
	$r->add_textbox("company_name", TEXT, "Company Name");
	$r->add_textbox("email", TEXT, "Email");
	$r->change_property("email", USE_SQL_NULL, false);
	$r->change_property("email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("address1", TEXT, "Address Line 1");
	$r->add_textbox("address2", TEXT, "Address Line 2");
	$r->add_textbox("city", TEXT, "City");
	$r->add_textbox("province", TEXT, "Province");
	$r->add_select("state_code", TEXT, $states, "State");
	$r->add_textbox("zip", TEXT, "Zip");
	$r->add_select("country_code", TEXT, $countries, "Country");
	$r->add_textbox("phone", TEXT, "Phone");
	$r->add_textbox("daytime_phone", TEXT, "Daytime Phone");
	$r->add_textbox("evening_phone", TEXT, "Evening Phone");
	$r->add_textbox("cell_phone", TEXT, "Cell Phone");
	$r->add_textbox("fax", TEXT, "Fax");

	$r->add_textbox("delivery_name", TEXT, "Delivery Name");
	$r->add_textbox("delivery_first_name", TEXT, "Delivery First Name");
	$r->add_textbox("delivery_last_name", TEXT, "Delivery Last Name");
	$r->add_textbox("delivery_company_name", TEXT, "Delivery Company Name");
	$r->add_textbox("delivery_email", TEXT, "Delivery Email");
	$r->change_property("delivery_email", REGEXP_MASK, EMAIL_REGEXP);
	$r->add_textbox("delivery_address1", TEXT, "Delivery Address Line 1");
	$r->add_textbox("delivery_address2", TEXT, "Delivery Address Line 2");
	$r->add_textbox("delivery_city", TEXT, "Delivery City");
	$r->add_textbox("delivery_province", TEXT, "Delivery Province");
	$r->add_select("delivery_state_code", TEXT, $states, "Delivery State");
	$r->add_textbox("delivery_zip", TEXT, "Delivery Zip");
	$r->add_select("delivery_country_code", TEXT, $countries, "Delivery Country");
	$r->add_textbox("delivery_phone", TEXT, "Delivery Phone");
	$r->add_textbox("delivery_daytime_phone", TEXT, "Delivery Daytime Phone");
	$r->add_textbox("delivery_evening_phone", TEXT, "Delivery Evening Phone");
	$r->add_textbox("delivery_cell_phone", TEXT, "Delivery Cell Phone");
	$r->add_textbox("delivery_fax", TEXT, "Delivery Fax");

	$personal_number = 0;
	$delivery_number = 0;
	for($i = 0; $i < sizeof($parameters); $i++)
	{                                    
		if($order_info["show_" . $parameters[$i]] == 1) {
			$personal_number++;
			if($order_info[$parameters[$i] . "_required"] == 1) {
				$r->parameters[$parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters[$parameters[$i]][SHOW] = false;
		}
		if($order_info["show_delivery_" . $parameters[$i]] == 1) {
			$delivery_number++;
			if($order_info["delivery_" . $parameters[$i] . "_required"] == 1) {
				$r->parameters["delivery_" . $parameters[$i]][REQUIRED] = true;
			}
		} else {
			$r->parameters["delivery_" . $parameters[$i]][SHOW] = false;
		}
	}

	$r->add_checkbox("same_as_personal", INTEGER);
	$r->change_property("same_as_personal", USE_IN_SELECT, false);
	$r->change_property("same_as_personal", USE_IN_INSERT, false);
	$r->change_property("same_as_personal", USE_IN_UPDATE, false);
	if($personal_number < 1 || $delivery_number < 1) {
		$r->parameters["same_as_personal"][SHOW] = false;
	}

	$r->get_form_values();
	$r->set_value("user_id", $user_id);
	$r->set_value("tax_name", $tax_name);
	$r->set_value("tax_percent", $tax_percent);
	$r->set_value("tax_total", $tax_cost);
	$variables["user_id"] = $r->get_value("user_id");
	$variables["tax_name"] = $tax_name;
	$variables["tax_percent"] = $tax_percent;
	$variables["tax_cost"] = $tax_cost;
	$variables["tax_total"] = $tax_cost;

	if(strlen($operation))
	{
		if($is_update) {
			$r->errors .= $sc_errors;
			if($total_shipping_types > 1 && !strlen($shipping_type_id)) {
				$r->errors .= REQUIRED_DELIVERY_MSG;
			}
	    
			if($r->get_value("same_as_personal")) {
				for($i = 0; $i < sizeof($parameters); $i++) { 
					if($order_info["show_delivery_" . $parameters[$i]] == 1 && $order_info["show_" . $parameters[$i]] == 1) {
						$r->set_value("delivery_" . $parameters[$i], $r->get_value($parameters[$i]));
					}
				}
			}
	  
			$is_valid = $r->validate();
		} else {
			$is_valid = false;
		}

		if($is_valid)
		{
			if(strtolower($db_type) != "mysql") {
				$db->query("SELECT MAX(order_id) FROM " . $table_prefix . "orders");
				$db->next_record();
				$order_id = $db->f(0) + 1;
				$variables["order_id"] = $order_id;
				$r->change_property("order_id", USE_IN_INSERT, true);
				$r->set_value("order_id", $order_id);
			}
			$r->set_value("order_status", 1);

			$variables["total_buying"] = $total_buying;
			$variables["goods_total"] = $goods_total;
			$variables["weight_total"] = $weight_total;
			$variables["shipping_type_id"] = $shipping_type_id;
			$variables["shipping_type"] = $shipping_type_desc;
			$variables["shipping_cost"] = $shipping_cost;

			$r->set_value("total_buying", $total_buying);
			$r->set_value("goods_total",  $goods_total);
			$r->set_value("total_quantity", $total_quantity);
			$r->set_value("weight_total",  $weight_total);

			$r->set_value("total_discount", 0);
			$r->set_value("shipping_type_id", $shipping_type_id);
			$r->set_value("shipping_type_desc", $shipping_type_desc);
			$r->set_value("shipping_cost", $shipping_cost);

			for($i = 0; $i < sizeof($parameters); $i++) { 
				$variables[$parameters[$i]] = $r->get_value($parameters[$i]);
				$variables["delivery_" . $parameters[$i]] = $r->get_value("delivery_" . $parameters[$i]);
			}

			$address = $r->get_value("address2") ? ($r->get_value("address1") . " " . $r->get_value("address2")) : $r->get_value("address1");
			$delivery_address = $r->get_value("delivery_address2") ? ($r->get_value("delivery_address1") . " " . $r->get_value("delivery_address2")) : $r->get_value("delivery_address1");
			$variables["address"] = $address;
			$variables["delivery_address"] = $delivery_address;
			$variables["state"] = get_array_value($r->get_value("state_code"), $states);
			$variables["country"] = get_array_value($r->get_value("country_code"), $countries); 
			$variables["delivery_state"] = get_array_value($r->get_value("delivery_state_code"), $states);
			$variables["delivery_country"] = get_array_value($r->get_value("delivery_country_code"), $countries); 
			$t->set_var("state", $variables["state"]);
			$t->set_var("country", $variables["country"]);
			$t->set_var("delivery_state", $variables["delivery_state"]);
			$t->set_var("delivery_country", $variables["delivery_country"]);

/*
			$country_code = $r->is_empty("delivery_country_code") ? $r->get_value("country_code") : $r->get_value("delivery_country_code");
			$state_code = $r->is_empty("delivery_state_code") ? $r->get_value("state_code") : $r->get_value("delivery_state_code");
			$province = $r->is_empty("delivery_province") ? $r->get_value("province") : $r->get_value("delivery_province");
			$tax_name = ""; $tax_percent = 0; $tax_cost = 0;
			// look up for tax rate
			if(strlen($country_code)) 
			{
				$sql  = " SELECT tax_name, tax_percent FROM " . $table_prefix . "tax_rates ";
				$sql .= " WHERE country_code=" . $db->tosql($country_code, TEXT);
				$def_region_sql = " AND (region=" . $db->tosql($state_code, TEXT) . " OR region=" . $db->tosql($province, TEXT) . ")";
				$any_region_sql = " AND (region IS NULL OR region='')";

				$db->query($sql . $def_region_sql);
				$is_tax = $db->next_record();
				if(!$is_tax) {
					$db->query($sql . $any_region_sql);
					$is_tax = $db->next_record();
				}
				if($is_tax) {
					$tax_name = $db->f("tax_name");
					$tax_percent = $db->f("tax_percent");
					$tax_cost = ($order_total / 100) * $tax_percent;
					$tax_cost = round($tax_cost, 2);
					$order_total += $tax_cost;
					$variables["tax_name"] = $tax_name;
					$variables["tax_percent"] = $tax_percent;
					$variables["tax_cost"] = $tax_cost;
					$variables["tax_total"] = $tax_cost;
					$t->set_var("tax_name", $tax_name);
					$t->set_var("tax_cost", $currency_left . number_format($tax_cost, 2) . $currency_right);
					$t->set_var("tax_total", $currency_left . number_format($tax_cost, 2) . $currency_right);
					$t->parse("tax", false);
					$items_text .= $tax_name . ": " . $currency_left . number_format($tax_cost, 2) . $currency_right . "\n";
				}
			}
//*/
  
			$r->set_value("order_total",  $order_total);
			$variables["order_total"] = $order_total;
			$variables["items"] = $items_text;
			$variables["basket"] = $items_text;
			$variables["description"] = $items_text;
  
			$t->parse("basket", false);
			$basket_parsed = true;

/*
			$r->set_value("tax_name", $tax_name);
			$r->set_value("tax_percent", $tax_percent);
			$r->set_value("tax_total", $tax_cost);*/

			$order_placed_date = va_time();
			$order_placed_date_string = va_date($datetime_show_format, $order_placed_date);
			$variables["order_placed_date"] = $order_placed_date;
			$r->set_value("order_placed_date", $order_placed_date);
			if($r->insert_record())
			{
				if($db_type == "mysql") {
					$db->query("SELECT LAST_INSERT_ID()");
					$db->next_record();
					$order_id = $db->f(0);
					$r->set_value("order_id", $order_id);
					$variables["order_id"] = $order_id;
				}
				$oi = new VA_Record($table_prefix . "orders_items");
				$oi->add_where("order_item_id", INTEGER);
				$oi->add_textbox("order_id", INTEGER);
				$oi->set_value("order_id", $order_id);
				$oi->add_textbox("item_id", INTEGER);
				$oi->add_textbox("item_type_id", TEXT);
				$oi->add_textbox("item_status", INTEGER);
				$oi->set_value("item_status", 1);
				$oi->add_textbox("item_name", TEXT);
				$oi->add_textbox("item_properties", TEXT);
				$oi->add_textbox("buying_price", NUMBER);
				$oi->add_textbox("price", NUMBER);
				$oi->add_textbox("weight", NUMBER);
				$oi->add_textbox("quantity", NUMBER);
				$oi->add_textbox("downloadable", NUMBER);

				$r_id = new VA_Record($table_prefix . "items_downloads");
				$r_id->add_textbox("order_id", INTEGER);
				$r_id->set_value("order_id", $order_id);
				$r_id->add_textbox("user_id", INTEGER);
				$r_id->set_value("user_id", $user_id);
				$r_id->add_textbox("order_item_id", INTEGER);
				$r_id->add_textbox("item_id", INTEGER);
				$r_id->add_textbox("download_path", TEXT);
				$r_id->add_textbox("activated", INTEGER);
				$r_id->add_textbox("max_downloads", INTEGER);
				$r_id->add_textbox("download_added", DATETIME);
				$r_id->add_textbox("download_expiry", DATETIME);

				$op = new VA_Record($table_prefix . "orders_items_properties");
				$op->add_textbox("order_id", INTEGER);
				$op->set_value("order_id", $order_id);
				$op->add_textbox("order_item_id", INTEGER);
				$op->add_textbox("property_id", INTEGER);
				$op->add_textbox("property_name", TEXT);
				$op->add_textbox("property_value", TEXT);
				$op->add_textbox("additional_price", NUMBER);
				$op->add_textbox("additional_weight", NUMBER);

				$sql  = " SELECT setting_value FROM " . $table_prefix . "global_settings ";
				$sql .= " WHERE setting_type='order_final' ";
				$sql .= " AND setting_name='max_downloads' ";
				$max_downloads = get_db_value($sql);

				for($i = 0; $i < sizeof($items); $i++)
				{
					list($item_id, $item_type_id, $item_name, $properties_info, $item_properties, $buying_price, $price, $weight, $quantity, $downloadable, $download_period, $download_path) = $items[$i];
					$oi->set_value("item_id", $item_id);
					$oi->set_value("item_type_id", $item_type_id);
					$oi->set_value("item_name", $item_name);
					$oi->set_value("item_properties", $item_properties);
					$oi->set_value("buying_price", $buying_price);
					$oi->set_value("price", $price);
					$oi->set_value("weight", $weight);
					$oi->set_value("quantity", $quantity);
					$oi->set_value("downloadable", $downloadable);

					if (strtolower($db_type) != "mysql") {
						$db->query("SELECT MAX(order_item_id) FROM " . $table_prefix . "orders_items");
						$db->next_record();
						$order_item_id = $db->f(0) + 1;
						$oi->change_property("order_item_id", USE_IN_INSERT, true);
						$oi->set_value("order_item_id", $order_item_id);
					}

					if($oi->insert_record())
					{
						if($db_type == "mysql") {
							$db->query("SELECT LAST_INSERT_ID()");
							$db->next_record();
							$order_item_id = $db->f(0);
						}
						// add properties
						if(is_array($properties_info) && sizeof($properties_info) > 1) {
							$op->set_value("order_item_id", $order_item_id);
							for($pi = 0; $pi < sizeof($properties_info); $pi++) {
								list($property_id, $property_name, $property_value, $pr_add_price, $pr_add_weight) = $properties_info[$pi];
								$op->set_value("property_id", $property_id);
								$op->set_value("property_name", $property_name);
								$op->set_value("property_value", $property_value);
								$op->set_value("additional_price", $pr_add_price);
								$op->set_value("additional_weight", $pr_add_weight);
								$op->insert_record();
							}
						}

						// add download link
						if ($downloadable) {
							$download_paths = split(";", $download_path);
							for($dl = 0; $dl < sizeof($download_paths); $dl++) {
								$download_path_cur = trim($download_paths[$dl]);
								if($download_path_cur) {
									$r_id->set_value("order_item_id", $order_item_id);
									$r_id->set_value("item_id", $item_id);
									$r_id->set_value("download_path", $download_path_cur);
						  
									$r_id->set_value("activated", 0);
									$r_id->set_value("max_downloads", $max_downloads * $quantity);
									$r_id->set_value("download_added", va_time());
									$download_expiry = mktime(0,0,0, date("m"), date("d") + intval($download_period), date("Y"));
									$r_id->set_value("download_expiry", va_time($download_expiry));
									$r_id->insert_record();
								}
							}
						}

						$sql  = " UPDATE " . $table_prefix . "items SET ";
						$sql .= " stock_level=stock_level-" . $db->tosql($quantity, NUMBER);
						$sql .= " WHERE item_id=" . $db->tosql($item_id, INTEGER);
						$db->query($sql);
					}
				}

				$order_admin_email = $order_info["admin_email"] ? $order_info["admin_email"] : $settings["admin_email"];
				if($order_info["admin_notification"])
				{
					$t->set_block("admin_subject", $order_info["admin_subject"]);
					$t->set_block("admin_message", $order_info["admin_message"]);
					$r->set_parameters();
					$t->set_var("goods_total", $currency_left . number_format($goods_total, 2) . $currency_right);
					$t->set_var("shipping_cost", $currency_left . number_format($shipping_cost, 2) . $currency_right);
					$t->set_var("tax_percent", number_format($tax_percent, 2) . "%");
					$t->set_var("order_total", $currency_left . number_format($order_total, 2) . $currency_right);
					$t->set_var("order_placed_date", $order_placed_date_string);

					$mail_to = get_setting_value($order_info, "admin_email", $settings["admin_email"]);
					$mail_from = get_setting_value($order_info, "admin_mail_from", $settings["admin_email"]);
					$mail_cc = get_setting_value($order_info, "cc_emails");
					$mail_bcc = get_setting_value($order_info, "admin_mail_bcc");
					$mail_reply_to = get_setting_value($order_info, "admin_mail_reply_to");
					$mail_return_path = get_setting_value($order_info, "admin_mail_return_path");
					$mail_type = get_setting_value($order_info, "admin_message_type");
					$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

					if (!$mail_type) {
						$t->set_var("basket", $items_text);
						$t->set_var("items", $items_text);
					}
					$t->parse("admin_subject", false);
					$t->parse("admin_message", false);

					$admin_message = str_replace("\r", "", $t->get_var("admin_message"));
					mail($mail_to, $t->get_var("admin_subject"), $admin_message, $email_headers);
				}		 
				if($order_info["user_notification"])
				{
					$t->set_block("user_subject", $order_info["user_subject"]);
					$t->set_block("user_message", $order_info["user_message"]);
					$r->set_parameters();
					$t->set_var("goods_total", $currency_left . number_format($goods_total, 2) . $currency_right);
					$t->set_var("shipping_cost", $currency_left . number_format($shipping_cost, 2) . $currency_right);
					$t->set_var("tax_percent", number_format($tax_percent, 2) . "%");
					$t->set_var("order_total", $currency_left . number_format($order_total, 2) . $currency_right);
					$t->set_var("order_placed_date", $order_placed_date_string);

					$mail_from = get_setting_value($order_info, "user_mail_from", $settings["admin_email"]);
					$mail_cc = get_setting_value($order_info, "user_mail_cc");
					$mail_bcc = get_setting_value($order_info, "user_mail_bcc");
					$mail_reply_to = get_setting_value($order_info, "user_mail_reply_to");
					$mail_return_path = get_setting_value($order_info, "user_mail_return_path");
					$mail_type = get_setting_value($order_info, "user_message_type");
					$email_headers = get_email_headers($mail_from, $mail_cc, $mail_bcc, $mail_reply_to, $mail_return_path, $mail_type);

					if (!$mail_type) {
						$t->set_var("basket", $items_text);
						$t->set_var("items", $items_text);
					}
					$t->parse("user_subject", false);
					$t->parse("user_message", false);

					$user_email = strlen($r->get_value("email")) ? $r->get_value("email") : $r->get_value("delivery_email");
					$user_message = str_replace("\r", "", $t->get_var("user_message"));
					mail($user_email, $t->get_var("user_subject"), $user_message, $email_headers);
				}		 
			}
			$vc = md5($order_id . $order_placed_date[3].$order_placed_date[4].$order_placed_date[5]);
			$variables["vc"] = $vc;
			$sql = "SELECT setting_value FROM " . $table_prefix . "global_settings WHERE setting_name='payment_id' AND setting_type='global'";
			$payment_id = get_db_value($sql);
			if($payment_id)
			{
				$db->query("SELECT * FROM " . $table_prefix . "payment_systems WHERE payment_id=" . $db->tosql($payment_id, INTEGER));
				$db->next_record();
				$return_page  = $db->f("payment_url");
				$submit_method = $db->f("submit_method");
				if($submit_method == "POST") {
					$return_page  = "payment.php";
					$return_page .= "?order_id=" . urlencode($order_id) . "&vc=" . urlencode($vc);
				} else {
					$parameter_number = 0;
					$db->query("SELECT * FROM " . $table_prefix . "payment_parameters WHERE payment_id=" . $db->tosql($payment_id, INTEGER));
					while($db->next_record())
					{
						$parameter_name = $db->f("parameter_name");
						$parameter_source = $db->f("parameter_source");
						$parameter_type = $db->f("parameter_type");
						if(preg_match("/\{digit\}/", $parameter_name) || preg_match("/\{no_digit\}/", $parameter_name)) {
							for($i = 0; $i < sizeof($cart_items); $i++) {
								$parameter_number++;
								$cart_item = $cart_items[$i];
								$digit_parameter = str_replace("{digit}", ($i + 1), $parameter_name);
								$digit_parameter = str_replace("{no_digit}", "", $digit_parameter);
								$return_page .= ($parameter_number == 1) ? "?" : "&";
								if($parameter_type == "CONSTANT") {
									$return_page .= $digit_parameter . "=" . urlencode($parameter_source);
								} else if($parameter_type == "VARIABLE") {
									if(preg_match("/[\,\;\:\s]/", $parameter_source, $match)) {
										$separator = $match[0];
										$parameter_sources = split($separator, $parameter_source);
										$parameter_value = "";
										for($p = 0; $p < sizeof($parameter_sources); $p++) {
											if ($p != 0) { $parameter_value .= $separator; }
											$l_source = strtolower($parameter_sources[$p]);
											$parameter_value .= isset($cart_item[$l_source]) ? $cart_item[$l_source] : $parameter_sources[$p];
										}
										$return_page .= $digit_parameter . "=" . urlencode($parameter_value);
									} else {
										$l_source = strtolower($parameter_source);
										$parameter_value = isset($cart_item[$l_source]) ? $cart_item[$l_source] : $parameter_source;
										$return_page .= $digit_parameter . "=" . urlencode($parameter_value);
									}
								}
							}
						} else {
							$parameter_number++;
							$return_page .= ($parameter_number == 1) ? "?" : "&";
							if($parameter_type == "CONSTANT") {
								$return_page .= $parameter_name . "=" . urlencode($parameter_source);
							} else if($parameter_type == "VARIABLE") {
								if(preg_match("/[\,\;\:\s]/", $parameter_source, $match)) {
									$separator = $match[0];
									$parameter_sources = split($separator, $parameter_source);
									$parameter_value = "";
									for($p = 0; $p < sizeof($parameter_sources); $p++) {
										if ($p != 0) { $parameter_value .= $separator; }
										$l_source = strtolower($parameter_sources[$p]);
										$parameter_value .= isset($variables[$l_source]) ? $variables[$l_source] : $parameter_sources[$p];
									}
									$return_page .= $parameter_name . "=" . urlencode($parameter_value);
								} else {
									$l_source = strtolower($parameter_source);
									$parameter_value = isset($variables[$l_source]) ? $variables[$l_source] : $parameter_source;
									$return_page .= $parameter_name . "=" . urlencode($parameter_value);
								}
							}
						}
					}
				}
			}
			else
			{
				$return_page  = "credit_card_info.php";
				$return_page .= "?order_id=" . urlencode($order_id) . "&vc=" . urlencode($vc);
			}
			if(!$user_id) { // set cookies with user info for non-registered users
				for($i = 0; $i < sizeof($parameters); $i++) { 
					setcookie("cookie_" . $parameters[$i], $r->get_value($parameters[$i]), time() + 3600 * 24 * 366);
					setcookie("cookie_delivery_" . $parameters[$i], $r->get_value("delivery_" . $parameters[$i]), time() + 3600 * 24 * 366);
				}
			}
			header("Location: " . $return_page);
			exit;
		}
	}/* if user can update his order details
	else if($order_id) // get user details from order
	{
		$sql = " SELECT * FROM " . $table_prefix . "orders WHERE order_id=" . $db->tosql($order_id, INTEGER);
		$db->query($sql);
		if($db->next_record())
		{
			for($i = 0; $i < sizeof($parameters); $i++) { 
				$r->set_value($parameters[$i], $db->f($parameters[$i]));
				$r->set_value("delivery_" . $parameters[$i], $db->f("delivery_" . $parameters[$i]));
			}
		}
	}*/
	else if($user_id) // get user details 
	{
		$sql = " SELECT * FROM " . $table_prefix . "users WHERE user_id=" . $db->tosql($user_id, INTEGER);
		$db->query($sql);
		if($db->next_record())
		{
			for($i = 0; $i < sizeof($parameters); $i++) { 
				$r->set_value($parameters[$i], $db->f($parameters[$i]));
				$r->set_value("delivery_" . $parameters[$i], $db->f("delivery_" . $parameters[$i]));
			}
		}
	} else { // set default values from cookies
		for($i = 0; $i < sizeof($parameters); $i++) { 
			$r->set_value($parameters[$i], get_cookie("cookie_" . $parameters[$i]));
			$r->set_value("delivery_" . $parameters[$i], get_cookie("cookie_delivery_" . $parameters[$i]));
		}
	}

	if(!$basket_parsed) {
		$t->parse("basket", false);
	}

	$r->set_parameters();

	if($personal_number > 0) {
		$t->parse("personal", false);
	}

	if($delivery_number > 0) {
		$t->parse("delivery", false);
	}

	if(strlen(trim($order_info["intro_text"])))
	{
		$t->set_var("intro_text", $order_info["intro_text"]);
		$t->parse("intro_block", false);
	}

	include("./header.php");
	include("./footer.php");

	$t->pparse("main");

?>